// ADDITIVITE.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// En cas d'alignement de points de la matrice A, les prfrences correspondantes de la matrice P
// doivent vrifier une condition d'additivit.
//
if ~exists("messageadd1") then messageadd1='L o des points sont aligns, ...
les prfrences doivent tre additives. Je propose donc de prendre les distances ...
entre les points, de les rapprocher de 1 et d''appliquer une isomtrie alatoire afin de dsaligner les points.' ; end ;
if ~exists("messageadd2") then messageadd2='Les distances valent :' ; end ;
if ~exists("messageadd3") then messageadd3='Aprs troncature des dernires lignes, les points qui ralisent les distances sont :' ; end ;
//
exec("mesure.sci",-1) ;
exec("testpref.sci",-1) ;
exec("SILtestpoint.sci",-1) ;
if ~testpref(A,P) then write(%io(2),string(messageadd1)) ; 
 if ~exists('D') then D=mesure(A) ;
 end ;
 write(%io(2),string(messageadd2)) ; 
 disp('D=') ;
 disp(D) ;
 D=D.^alpha ;
 [chi,E,A]=SILtestpoint(D,alpha) ;
//
// rduction des dimensions de l'espace perceptif
//
 s=size(A) ;
 DIMENSION=s(1) ;
 DiM=dimreduction+1 ;
 for i=DiM:DIMENSION , A(DiM,:)=[] ;
 end ;
 while ~testpref(A,P) , D=D.^alpha ; 
 [chi,E,A]=SILtestpoint(D,alpha) ; 
//
// rotation alatoire
//
  s=size(A) ;
  DIMENSION=s(1) ;
  rho=.3*rand(DIMENSION,DIMENSION,'unif') ;
  RHO=rho'-rho ;
  H=expm(RHO) ;
  A=H*A ;
//
// rduction des dimensions de l'espace perceptif
//
  DiM=dimreduction+1 ;
  for i=DiM:DIMENSION , A(DiM,:)=[] ;
  end ;
 end ;
 E=mesure(A) ;
// write(%io(2),string(messagetestpoint1))
// disp('chi=') ;
// disp(chi) ;
 write(%io(2),string(messagetestpoint2))
 disp('E=') ;
 disp(E) ;
 write(%io(2),string(messageadd3)) ; 
 disp('A=') ;
 disp(A) ;
end ;
