// DIST.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Entrer les distances et calculer les coordonnes des sommets.
// 
//
if ~exists("messagesaisie91") then messagesaisie91='Pour saisir les distances une par une, taper u ; ...
Pour prendre les distances dans un fichier, taper f' ; end ;
if ~exists("messagesaisie92") then messagesaisie92='Les distances ne sont pas suffisamment positives ! ...
Il faut modifier le fichier source des distances ou en donner un autre !' ; end ;
if ~exists("messagesaisie93") then messagesaisie93='Les distances ne sont pas suffisamment positives ! ...
Il faut ressaisir le vecteur des distances !' ; end ;
if ~exists("messagesaisie94") then messagesaisie94='Voici la matrice des distances :' ; end ;
//
if ~exists("messagebrut") then messagebrut='Voici la matrice dont les vecteurs colonnes ...
forment les coordonnes des points qui ralisent les distances brutes ...
que vous avez fournies ; ses coefficients peuvent tre complexes :' ; end ;
//
function [alpha,chi,n,taille,D,E,A]=DIST()
//
// entre des distances
//
write(%io(2),string(messagesaisie91)) ;
modedist=read(%io(1),1,1,'(a)') ; // waits for user's input
if modedist=='f' then  [n,taille,vv,probleme]=stockdist()
while probleme~=[] , write(%io(2),string(messagesaisie92)) ; [n,taille,vv,probleme]=stockdist() ; end ;
else 
[n,taille,vv,probleme]=saisiedist() ;
while probleme~=[] , write(%io(2),string(messagesaisie93)) ; [n,taille,vv,probleme]=saisiedist() ; end ;
end ;
//
// mise en forme des donnes sous forme de matrice carre avec une
// mchante astuce pour que la fonction zerosym gobe la dimension nn
//
v=vv' ; for k=1:n , D=zerosym(v,k) ; end ;
//
// affichage des donnes mises en forme
//
write(%io(2),string(messagesaisie94)) ;
disp('D=')
disp(D)
//
// cohsion des distances
//
write(%io(2),string(messagebrut)) ;
//n=nn ;
//E=D ;
disp('A=') ;
A=points(D,n) ;
disp(A) ;
//
// initialiser l'tranget
//
alpha=saisieetrange() ;
//
// calculer l'tranget et les points raliss
//
[chi,E,A]=testpoint(D,alpha) ;
endfunction ;

