// VECT.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Entrer les prfrences et calculer la fonction champ de vecteurs.
// 
//
if ~exists("messagesaisie95") then messagesaisie95='Pour saisir les prfrences une par une, taper u ; ...
Pour prendre les prfrences dans un fichier, taper f' ; end ;
if ~exists("messagesaisie96") then messagesaisie96='Le nombre de distances n''est pas le mme que celui ...
des prfrences ! Il faut modifier le fichier source des prfrences ou en donner un autre !' ; end ;
if ~exists("messagesaisie97") then messagesaisie97='Voici la matrice des prfrences :' ; end ;
//
if ~exists("messagebrut") then messagebrut='Voici la matrice dont les vecteurs colonnes ...
forment les coordonnes des points qui ralisent les distances brutes que vous avez fournies ; ...
ses coefficients peuvent tre complexes :' ; end ;
//
// entre des prfrences
//
exec("stockpref.sci",-1) ;
exec("saisiepref.sci",-1) ;
write(%io(2),string(messagesaisie95)) ;
modepref=read(%io(1),1,1,'(a)') ; // waits for user's input
if modepref=='f' then [wwww,ww]=stockpref() ;
 while taille~=wwww , write(%io(2),string(messagesaisie95)) ; [wwww,ww]=stockpref() ; end ;
 else ww=saisiepref(taille) ;
end ;
//
// mise en forme des donnes sous forme de matrice carre avec une
// mchante astuce pour que la fonction antisym gobe la dimension n
//
w=ww' ; for k=1:n , P=antisym(w,k) ; end ;
//
// affichage des donnes mises en forme
//
write(%io(2),string(messagesaisie97)) ;
disp('P=')
disp(P)
//
// cohsion des prfrences avec les distances
//
exec("ADDITIVITE.sci",0) ;
//
// travail sur les champs
//
exec("champ.sci",-1) ;
//
// effacer des constantes
//
clear wwww ;
clear ww ;

