// maillage.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Fabriquer une matrice de maillage de taille arbitraire.
// 
function M=maillage(d,m)
//
// dimensionnement de la matrice 
//
MMM=nulle(d) ;
MM=[] ;
for i=1:m ,
 MM=[MM;MMM] ;
end ;
p=m ;
for i=1:d-1 ,
 p=p*m ;
end;
//
// entre des coefficients 
//
for i=1:p ,
 reste=0 ;
 quotient=i-1 ;
 for j=1:d , 
  reste=modulo(quotient,m) ;
  quotient=int((quotient-reste)/m) ;
  MM(i,j)=reste ;
 end ;
end ;
M=MM ;
endfunction
