// polarisation.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Calculer la matrice B des polarisations pour le champ de vecteurs 
// en fonction de la matrice de prfrences P, du paramtre a de partition de l'unit,
// de la matrice des sommets A et calculer la taille de P
//
exec("distsegment.sci",-1) ;
exec("unipart.sci",-1) ;
exec("annulation.sci",-1) ;
//
function y=polarisation(a,R,A,P)
s=size(P,2) ;
B=nulle(s)
for i=1:s-1 ,
 ii=i+1 ;
 for j=ii:s ,
  function y=fff(t), Y=A(:,i); YY=A(:,j); YYY=(1-t)*Y+t*YY; yy=annulation(a,R,A,i,j,YYY); y=yy, endfunction ;
  POLAR=intg(0,1,fff) ; //intg(0,1,fff,0,marge) ;
  B(i,j)=P(i,j)/POLAR ;
  clear fff ;
 end;
end;
y=B ;
endfunction ;
