// reduire.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Rduire la dimension de l'espace perceptif.
//
if ~exists("messagereduire1") then messagereduire1='Quelle dimension souhaitez-vous pour la rduction ? ...
Il sera encore possible de tronquer aprs.' ; end ;
if ~exists("messagereduire2") then messagereduire2='Pour rduire la dimension de l''espace perceptif, ...
deux rcurrences sont proposes : ...
par projection sur le moment d''inertie autour du barycentre (taper i), ...
par Analyse en Composantes Principales normalise (taper a). ...
Pour prendre simplement les premires lignes, taper l.' ; end ;
if ~exists("messagereduire3") then messagereduire3='Voulez-vous tronquer la dernire ligne ? ...
Oui : taper o ; non : taper n.' ; end ;
//
exec("inert.sci",-1) ;
exec("acp.sci",-1) ;
//
function reduc=reduction(A,choixreduire,dimreduc)
//
// mchante astuce pour fabriquer une matrice nulle de taille voulue
//
reduc=nulle(n) ;
for i=n:-1:dimreduc+1 , reduc(i,:)=[] ; end ;
//
aa=size(A) ;
aaa=aa(1) ;
minimum=min(dimreduc,aaa) ;
select choixreduire ,
 case 'l' then for i=1:minimum , reduc(i,:)=A(i,:) ; end ;
//
// Rduction par Analyse en Composantes Principales par rapport  l'origine des coordonnes.
//
 case 'a' then ...
  i=1 ; [y,yy]=acp(A,i) ; reduc(1,:)=y ; 
  for i=2:dimreduc , ...
   [z,yy]=acp(yy,i) ; reduc(i,:)=z ; 
  end ;
//
// Rduction par projection sur le moment d''inertie autour du barycentre ; 
// l'origine des coordonnes n'a aucune importance.
//
 case 'i' then ...
  i=1 ; [y,yy]=inertie(A,i) ; reduc(1,:)=y ; 
  for i=2:dimreduc , ...
   [z,yy]=inertie(yy,i) ; reduc(i,:)=z ; 
  end ;
end ;
disp(reduc) ;
write(%io(2),string(messagereduire3)) ;
choixtronquer=read(%io(1),1,1,'(a)') ;
while and([reduc~=[],choixtronquer=='o']) ,
 reduc($,:)=[] ;
 disp(reduc) ;
 if reduc==[] then break ; end ;
 write(%io(2),string(messagereduire3)) ;
 choixtronquer=read(%io(1),1,1,'(a)') ;
end ;
endfunction ;
