// testpoint.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Passer les distances dans la matrice D  la puissance alpha
// tant que la partie imaginaire des points A
// a une norme L2 suprieure  marge, pour donner une matrice E.
// L'tranget de D est chi.
// 
if ~exists("messagetestpoint1") then ...
messagetestpoint1='L''tranget des distances brutes est :' ; end ;
if ~exists("messagetestpoint2") then ...
messagetestpoint2='Les distances ralisables sont :' ; end ;
if ~exists("messagetestpoint3") then ...
messagetestpoint3='Les vecteurs colonnes de la matrice A sont les coordonnes des points ralisant les distances :' ; end ;
//
function [chi,E,A]=testpoint(D,alpha)
beta=1 ;
E=D ;
A=points(D,n) ;
//
// t est le dfaut de ralit de A.
//
T=imag(A) ;
t=trace(T'*T) ; 
while t > marge, E=E.^alpha ; 
 A=points(E,n) ;
 beta=beta*alpha ;
 T=imag(A) ;
 t=trace(T'*T) ; 
end ;
A=real(A) ;
chi=1-beta ;
write(%io(2),string(messagetestpoint1))
disp('chi=') ;
disp(chi) ;
write(%io(2),string(messagetestpoint2))
disp('E=') ;
disp(E) ;
write(%io(2),string(messagetestpoint3))
disp('A=') ;
disp(A) ;
clear t ;
endfunction ;
