// 2dessin.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Dessiner le champ de vecteur prfrences V en dimension 2.
//
//
if ~exists("messagedessin1") then messagedessin1='Les valeurs numriques du champ seront values sur un pav ...
dont on va prciser la diagonale et le maillage.' ; end ;
if ~exists("messagedessin2") then messagedessin2='Quelles sont les coordonnes du dbut de la diagonale ?' ; end ;
if ~exists("messagedessin3") then messagedessin3='Quelles sont les coordonnes de la fin de la diagonale ?' ; end ;
if ~exists("messagedessin4") then messagedessin4='Quel est le nombre de mailles sur une arte du pav ?' ; end ;
if ~exists("messagedessin5") then messagedessin5='Quel est le grossissement des flches sur le dessin ?' ; end ;
//
if ~exists("messagetempo2") then messagetempo2='Je calcule les valeurs numriques !' ; end ;
//
function y=deuxdessin(d)
//
// protection pour la dimension 2 (et si les paramtres a,R,c,N,seuil,B sont dfinis)
//
if d==2 then ...
RNTvide=unix_g("if test -e ../RNT/arrivee ; then rm ../RNT/* ; fi") ;
write(%io(2),string(messagedessin1)) ;
write(%io(2),string(messagedessin2)) ;
depart=read(%io(1),2,1) ;
write(%io(2),string(messagedessin3)) ;
arrivee=read(%io(1),2,1) ;
write(%io(2),string(messagedessin4)) ;
m=max([int(read(%io(1),1,1)),2]) ;
write(%io(2),string(messagetempo2)) ;
M=maillage(2,m) ;
p=m^2 ;
O=ones(p,1) ;
res=zeros(p,2) ;
RES=[] ;
DIAGO=diag(arrivee-depart)/m ;
echantillon=depart'.*.O + M *DIAGO ;
//
// surveillance des piles
//
pile=stacksize() ;
pileglobale=gstacksize() ;
disp('stacksize()= ! '+string(pile(1))+'  '+string(pile(2))+' ! ; gstacksize()= ! '+string(pileglobale(1))+'  '+string(pileglobale(2))+' !' ) ;
//
write(%io(2),string(messagedessin5)) ;
fleche=read(%io(1),1,1) ;
write(%io(2),string(messagetempo2)) ;
//
// chantillonnage et calcul
//
for i=1:p ,
 machin=echantillon(i,:)' ;
 vecteur=V(a,R,c,N,seuil,A,B,machin)*fleche ;
 ligne=[string(machin(1))+' '+string(machin(2))+' '+string(vecteur(1))+' '+string(vecteur(2))] ;
 RES=[RES;ligne] ;
end ;
//
// fabrication des tiquettes
//
AA=string(A(1,:)'+.1) ;
AAA=string(A(2,:)'+.1) ;
etiquette=string([1:n]') ;
etiq=[] ;
ette=[] ;
virgule=[] ;
for i=1:n,
 etiq=[etiq ; 'set label '"'] ;
 ette=[ette ; ''" at '] ;
 virgule=[virgule ; ','] ;
end ;
nom=etiq+etiquette+ette+AA+virgule+AAA ;
//
// stockage temporaire des vraies donnes
//
parametres=param(a,R,c,N,seuil,alpha,chi) ;
parametres=[parametres;'m = '+string(m);'fleche = '+string(fleche)] ;
write('../RNT/res1',RES) ; 
write('../RNT/res0',A') ; 
write('../RNT/etiquette',nom) ; 
write('../RNT/parametres',parametres) ;
write('../RNT/arrivee',arrivee) ; 
write('../RNT/depart',depart) ; 
//
// instructions de dessin
//
desspoint='plot ['+string(depart(1))+':'+string(arrivee(1))+']['+string(depart(2))+':'+string(arrivee(2))+'] '"../RNT/res0'" with points' ;
desschamp='plot ['+string(depart(1))+':'+string(arrivee(1))+']['+string(depart(2))+':'+string(arrivee(2))+'] '"../RNT/res1'" with vector' ;
tracage=['set multiplot';
 'set xlabel '"x'"'; 'set ylabel '"y'"';
 nom;'show label';desspoint;desschamp;'set nomultiplot'] ;
//
// stockage temporaire des instructions de tracage du champ
//
write('../RNT/tracage.gpl',tracage) ; 
unix_w("xterm -e gnuplot ../RNT/tracage.gpl - &")
//
// surveillance des piles
//
pile=stacksize() ;
pileglobale=gstacksize() ;
disp('stacksize()= ! '+string(pile(1))+'  '+string(pile(2))+' ! ; gstacksize()= ! '+string(pileglobale(1))+'  '+string(pileglobale(2))+' !' ) ;
//
y='bouclage' ;
//
// fin de la protection de dimension
//
else y='bouclage' ;
end ;
endfunction ;
