// 3tronq.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Dessiner le champ de vecteur prfrences V en dimension 2.
//
//
if ~exists("messagedessin1") then messagedessin1='Les valeurs numriques du champ seront values sur un pav ...
dont on va prciser la diagonale et le maillage.' ; end ;
if ~exists("messagedessin2") then messagedessin2='Quelles sont les coordonnes du dbut de la diagonale ?' ; end ;
if ~exists("messagedessin3") then messagedessin3='Quelles sont les coordonnes de la fin de la diagonale ?' ; end ;
if ~exists("messagedessin4") then messagedessin4='Quel est le nombre de mailles sur une arte du pav ?' ; end ;
if ~exists("messagedessin5") then messagedessin5='Quel est le grossissement des flches sur le dessin ?' ; end ;
if ~exists("messagedessin6") then messagedessin6='Quel est, en degrs, le premier angle de rotation de prise de vue ?' ; end ;
if ~exists("messagedessin7") then messagedessin7='Quel est, en degrs, le deuxime angle de rotation de prise de vue ?' ; end ;
//
if ~exists("messagetempo2") then messagetempo2='Je calcule les valeurs numriques !' ; end ;
//
function y=troistronq(d)
//
// protection pour la dimension 3 (et si les paramtres a,R,c,N,seuil,B sont dfinis)
//
if d==3 then ...
RNTvide=unix_g("if test -e ../RNT/arrivee ; then rm ../RNT/* ; fi") ;
write(%io(2),string(messagedessin1)) ;
write(%io(2),string(messagedessin2)) ;
depart=read(%io(1),3,1) ;
write(%io(2),string(messagedessin3)) ;
arrivee=read(%io(1),3,1) ;
write(%io(2),string(messagedessin4)) ;
m=max([int(read(%io(1),1,1)),2]) ;
write(%io(2),string(messagetempo2)) ;
M=maillage(3,m) ;
p=m^3 ;
O=ones(p,1) ;
res=zeros(p,3) ;
RES=[] ;
DIV=[] ;
ROT=[] ;
rot=zeros(3,1) ;
diagonale=(arrivee-depart)/m ;
Diagonale=norm(diagonale) ;
DIAGO=diag(diagonale) ;
echantillon=depart'.*.O + M *DIAGO ;
//
// surveillance des piles
//
pile=stacksize() ;
pileglobale=gstacksize() ;
disp('stacksize()= ! '+string(pile(1))+'  '+string(pile(2))+' ! ; gstacksize()= ! '+string(pileglobale(1))+'  '+string(pileglobale(2))+' !' ) ;
//
write(%io(2),string(messagedessin5)) ;
fleche=read(%io(1),1,1) ;
write(%io(2),string(messagedessin6)) ;
PHI=string( max([0,min([180,read(%io(1),1,1)])]) ) ;
write(%io(2),string(messagedessin7)) ;
THETA=string( max([0,min([180,read(%io(1),1,1)])]) ) ;
write(%io(2),string(messagetempo2)) ;
//
// chantillonnage et calcul
//
for i=1:p,
 machin=echantillon(i,:)' ;
 vecteur=V(a,R,c,N,seuil,A,B,machin) ;
 VECTEUR=fleche*vecteur
 bidule=VECTEUR'*diagonale/Diagonale ;
 pointe=machin+0.95*VECTEUR-0.1*bidule*diagonale ;
 truc=machin+VECTEUR ;
 z=V(a,R,c,N,seuil,A,B,machin+[.01;0;0])-vecteur ;
 zz=V(a,R,c,N,seuil,A,B,machin+[0;.01;0])-vecteur ;
 zzz=V(a,R,c,N,seuil,A,B,machin+[0;0;0.01])-vecteur ;
//
// crasement en-dehors du convexe en tenant compte des itrations
// 
 s=size(A,2) ;
 conf=2^(s^3)*distconv(A,machin)*max([1,1/c])/R ; confinement=1/cosh(conf) ; 
// 
 div=machin(1)+100*fleche*(z(1)+zz(2)+zzz(3))*confinement ;
 rot(1)=machin(1)+100*fleche*(zz(3)-zzz(2))*confinement ;
 rot(2)=machin(2)+100*fleche*(zzz(1)-z(3))*confinement ;
 rot(3)=machin(3)+100*fleche*(z(2)-zz(1))*confinement ;
 ligne=[string(machin(1))+' '+string(machin(2))+' '+string(machin(3));
  string(truc(1))+' '+string(truc(2))+' '+string(truc(3));
  string(pointe(1))+' '+string(pointe(2))+' '+string(pointe(3));
  ' ';' '] ;
 rotationnel=[string(machin(1))+' '+string(machin(2))+' '+string(machin(3));
  string(rot(1))+' '+string(rot(2))+' '+string(rot(3));
  ' ';' '] ;
 divergence=[string(machin(1))+' '+string(machin(2))+' '+string(machin(3));
  string(div)+' '+string(machin(2))+' '+string(machin(3));
  ' ';' '] ;
 RES=[RES;ligne] ;
 DIV=[DIV;divergence] ;
 ROT=[ROT;rotationnel] ;
end ;
//
// fabrication des tiquettes
//
AA=string(A(1,:)'+.1) ;
AAA=string(A(2,:)'+.1) ;
AAAA=string(A(3,:)'+.1) ;
etiquette=string([1:n]') ;
etiq=[] ;
ette=[] ;
virgule=[] ;
for i=1:n,
 etiq=[etiq ; 'set label '"'] ;
 ette=[ette ; ''" at '] ;
virgule=[virgule ; ','] ;
end ;
nom=etiq+etiquette+ette+AA+virgule+AAA+virgule+AAAA ;
//
// stockage temporaire des vraies donnes
//
parametres=param(a,R,c,N,seuil,alpha,chi) ;
parametres=[parametres;'m = '+string(m);'fleche = '+string(fleche);'PHI = '+string(PHI);'THETA = '+string(THETA)] ;
write('../RNT/res0',A') ; 
write('../RNT/parametres',parametres) ;
write('../RNT/res1',string(RES)) ; 
write('../RNT/res2',string(DIV)) ; 
write('../RNT/res3',string(ROT)) ; 
write('../RNT/etiquette',nom) ; 
write('../RNT/arrivee',arrivee) ; 
write('../RNT/depart',depart) ; 
//
// instructions de dessin
//
desspoint='splot ['+string(depart(1))+':'+string(arrivee(1))+']['+string(depart(2))+':'+string(arrivee(2))+']['+string(depart(3))+':'+string(arrivee(3))+'] '"../RNT/res0'" with points' ;
desschamp='splot ['+string(depart(1))+':'+string(arrivee(1))+']['+string(depart(2))+':'+string(arrivee(2))+']['+string(depart(3))+':'+string(arrivee(3))+'] '"../RNT/res1'" with lines' ;
dessdiv='splot ['+string(depart(1))+':'+string(arrivee(1))+']['+string(depart(2))+':'+string(arrivee(2))+']['+string(depart(3))+':'+string(arrivee(3))+'] '"../RNT/res2'" with lines lt 3' ;
dessrot='splot ['+string(depart(1))+':'+string(arrivee(1))+']['+string(depart(2))+':'+string(arrivee(2))+']['+string(depart(3))+':'+string(arrivee(3))+'] '"../RNT/res3'" with lines lt 2' ;
tracage=['set multiplot';'set view '+PHI+' ,'+THETA;
 'set xlabel '"x'"'; 'set ylabel '"y'"';'set zlabel '"z'"';
 nom;'show label';desspoint;desschamp;dessdiv;dessrot;'set nomultiplot'] ;
//
// stockage temporaire des instructions de tracage du champ
//
write('../RNT/divrot.gpl',tracage) ; 
unix_w("xterm -e gnuplot ../RNT/divrot.gpl - &")
//
// surveillance des piles
//
pile=stacksize() ;
pileglobale=gstacksize() ;
disp('stacksize()= ! '+string(pile(1))+'  '+string(pile(2))+' ! ; gstacksize()= ! '+string(pileglobale(1))+'  '+string(pileglobale(2))+' !' ) ;
y='bouclage' ;
//
// fin de la protection de dimension
//
else y='bouclage' ;
end ;
endfunction ;