// acp.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Calculer le barycentre G et la composante principale I d'une famille de n points
// donns par une matrice points  d lignes et n colonnes, 
// puis projeter les points sur l'orthogonal de la composante principale.
// 
function [principal,projection]=acp(X,i)
S=size(X) ;
s=S(2) ;
//
normalisation=zeros(1,s) ;
for i=1:s ,
NORME=norm(X(:,i)) ;
 if NORME>marge then normalisation(i)=1/NORME ;
  else  normalisation(i)=0 ;
 end ;
end ;
//
PROJECTIF=X*diag(normalisation) ;
I=mean(PROJECTIF,'c') ;
N=I'*I ;
if N<10000*marge then I=zeros(I) ; 
 I(i)= 1 ;  N=1 ;
end ;
II=I*ones(1,s) ;
scalaires=sum(X .* II , 'r') ;
projection=X-N\II*diag(scalaires) ; 
principal=sqrt(N)\scalaires ;
endfunction ;
