// convexe.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Construire une distance du point x  l'enveloppe convexe
// de l'ensemble des points dont les coordonnes sont les colonnes de A,
// en fonction du paramtre stochastique N. Garder la matrice U.
//
// gnration des vecteurs unitaires de test
//
function [d,n,U]=pointeur(N,A)
[d,n]=size(A) ;
U=[] ;
for i=1:N
//
// rotation alatoire
//
 rho=9*rand(d,d,'unif') ;
 RHO=rho'-rho ;
 G=expm(RHO) ;
 U=[U G] ;
end ;
endfunction ;
//
// construction de la fonction distance
//
function y=distconv(A,x)
[d,n,U]=pointeur(N,A) ;
B=A-x*ones(1,n)
test=[] ;
for u=U
 scal=u'*B ;
 signe=sign(scal) ;
 plus=and(signe==1) ;
 moins=and(signe==-1) ;
 succes=or([plus moins]) ;
 if succes then essai=abs(mean(scal)) ; else essai=0 ; end ;
 test=[test essai] ;
end ;
y=mean(test) ;
endfunction ;
