// menu.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// saisir le vecteur vertical des distances vv avec smaphore d'erreur : probleme en fonction de marge,
// et saisir la taille nn de vv.
//
if ~exists("messagemenu1") then messagemenu1='Pour arrter maintenant, taper <ENTRE> directement ;';end ;
if ~exists("messagemenu21") then messagemenu21='Pour dessiner le champ de vecteurs prfrence ...
bidimensionnel d''aprs les donnes prcdentes, taper 2c ; ' ; end ;
if ~exists("messagemenu22") then messagemenu22='Pour dessiner le champ de vecteurs prfrence ...
bidimensionnel avec reprsentation horizontale de la divergence (en bleu) et verticale du rotationnel (en vert), taper 2d ; ' ; end ;
if ~exists("messagemenu23") then messagemenu23='Pour dessiner le champ de vecteurs prfrence ...
bidimensionnel avec divergence et rotationnel en tronquant les effets de bord, taper 2t ; ' ; end ;
if ~exists("messagemenu31") then messagemenu31='Pour dessiner le champ de vecteurs prfrence ...
tridimensionnel d''aprs les donnes prcdentes, taper 3c ; ' ; end ;
if ~exists("messagemenu32") then messagemenu32='Pour dessiner le champ de vecteurs prfrence ...
tridimensionnel avec reprsentation de la divergence le long de l''axe des x (en bleu) ...
et reprsentation du rotationnel (en vert), taper 3d ; ' ; end ;
if ~exists("messagemenu33") then messagemenu33='Pour dessiner le champ de vecteurs prfrence ...
tridimensionnel avec divergence et rotationnel, taper 3t ; ' ; end ;
if ~exists("messagemenu7") then messagemenu7='Pour sauvegarder les donnes, taper s ;' ; end ;
if ~exists("messagemenu8") then messagemenu8='Pour calculer la prfrence ...
entre deux points arbitraires, taper p ;' ; end ;
if ~exists("messagemenu9") then messagemenu9='Pour entrer de nouveaux paramtres du champ, taper m ;' ; end ;
if ~exists("messagetempo1") then messagetempo1='Je calcule le champ de vecteurs prfrence V !' ; end ;
//
function [a,R,c,N,seuil,B]=modif(alpha,chi)
//
// entre des paramtres de partition de l'unit
//
[a,R,c,N,seuil]=saisieunip() ;
disp('a=') ;
disp(a) ;
disp('R=') ;
disp(R) ;
disp('c=') ;
disp(c) ;
disp('N=') ;
disp(N) ;
disp('seuil=') ;
disp(seuil) ;
//
// initialisation du stockage temporaire
//
parametres=param(a,R,c,N,seuil,alpha,chi) ;
//
// Calcul de la polarisation du champ de vecteurs
//
write(%io(2),string(messagetempo1)) ; 
B=polarisation(a,R,A,P) ;
endfunction ;
//
function [y,z]=menu(DIM)
//
// initialisation du stockage temporaire
//
parametres=param(a,R,c,N,seuil,alpha,chi) ;
write(%io(2),string(messagemenu1)) ;
write(%io(2),string(messagemenu21)) ;
write(%io(2),string(messagemenu22)) ;
write(%io(2),string(messagemenu23)) ;
write(%io(2),string(messagemenu31)) ;
write(%io(2),string(messagemenu32)) ;
write(%io(2),string(messagemenu33)) ;
write(%io(2),string(messagemenu7)) ;
write(%io(2),string(messagemenu8)) ;
write(%io(2),string(messagemenu9)) ;
choixmenu=read(%io(1),1,1,'(a)') ;
select choixmenu ,
 case '2c' then y=deuxdessin(DIM) ; z='non' , 
 case '2d' then y=deuxdivrot(DIM) ; z='non' , 
 case '2t' then y=deuxtronq(DIM) ; z='non' , 
 case '3c' then y=troisdessin(DIM) ; z='non' , 
 case '3d' then y=troisdivrot(DIM) ; z='non' , 
 case '3t' then y=troistronq(DIM) ; z='non' , 
 case 's' then y=enregistre(DIM) ; z='non' ,
 case 'p' then y=preference(DIM) ; z='non' ,
 case 'm' then y='bouclage' ; z='oui' , 
 else y=[] ; z=[] ,
end ;
endfunction ;
