// testpref.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// En cas d'alignement de points de la matrice A, les prfrences correspondantes de la matrice P
// doivent vrifier une condition d'additivit.
//
if ~exists("messageTP1") then messageTP1='Il y a un problme de dimensions, j''arrte tout !' ; end ;
//
function y=testpref(A,P) 
s=size(A) ;
n=s(2) ;
t=size(P) ;
if or([t(1)~=t(2) n~=t]) then write(%io(2),string(messageTP1)) ; abort ;
end ;
D=mesure(A) ;
test=%f ;
for i=1:n ,
 for j=1:n ,
  for k=1:n ,
   test1=and([abs(D(i,k)-D(i,j)-D(j,k))<marge abs(P(i,k)-P(i,j)-P(j,k))>marge]) ;
   test2=and([abs(D(i,j)-D(i,k)-D(j,k))<marge abs(P(i,j)-P(i,k)-P(k,j))>marge]) ;
   test3=and([abs(D(i,k)-D(i,j)-D(j,k))<marge abs(P(i,k)-P(i,j)-P(j,k))>marge]) ;
   test=or([test test1 test2 test3]) ;
  end ;
 end ;
end ;
y=~test ;
endfunction 
