// unipart.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Dfinir la fonction phi de deux variables reeles 
// permettant de construire une partition de l'unit.
// La classe de phi est gale  la premire variable si celle-ci est strictement positive
// et est infinie si la premire variable est strictement ngative.
//
if ~exists("messageunipart") then ...
messageunipart='Ah la la ! Je ne peux pas m''en sortir ...
parce que le paramtre de partition de l''unit est trop proche de zro !' ; end ;
//
function y=phi(a,x) 
b=sign(a) ;
if abs(a)<1E-3 then write(%io(2),string(messageunipart)) ; abort ;
 else select b , 
  case 1 then y= x^a ; // y=(x^a)/(1+x^(2*a)) // y=(x^a)/(1+x^a) //
  case -1 then if x==0 then y=0 ; else y=exp(-x^a) ; end ; // y=exp(-(x^a)-(x^(-a))) // y=exp(-x^a-x^(-a)) //
 end ;
end ;
endfunction
